{
  Pomysowe "Hello World"
  5corpio
  2007r.
  Praca na konkurs unit1.pl

  Opis programu:

  Na samymy poczatku pobieramy sciezke do katalogu Windowsa (teraz pytanie jak zachowa sie
  program na Linuxie :D?)
  Nastepnie pobieramy liste wszystkich plikow z katalogu windowsa i teraz segregujemy
  pliki ze wzgledu na 1 literke w nazwie pliku i wybieramy tylko te pliki ktorych pierwsze
  litery to: H,E,L,O,W,R,D reszte olewamy. Nastepnie majac te pliki w osobnych listach stringow
  losujemy sobie dla kazdej literki z odpowiedniej listy 1 plik usuwamy z nazwy pliku cala reszte
  procz 1 literki i pozostaje nam wyswietlenie tych wynikow co daje nam w rezultacie:

  H
  E
  L
  L
  O

  W
  O
  R
  L
  D

  Dziekuje za uwage ]:->
}
program hello;

{$APPTYPE CONSOLE}

uses
  Windows, SysUtils, Classes;


type

  { Hello Klasa }
  THelloClass = class(TObject)
  private
    { }
    SRes : TSearchRec;
    { Wrzucamy 7 String listow po 1 dla kazdej literki : H,E,L,O,W,R,D }
    CharList : Array[0..6] of TStringList;
    { Sciezka do windowsa katalogu }
    WinPath : Array[0..255] of Char;
    { Wynikowa lista stringow z 1 plikiem do 1 literki }
    ResultList : TStringList;

    { Taka pomocnicza funkcja }
    Function CheckChar(c : Char) : Integer;
    { Losowanie rozne plikow }
    Procedure RandomFiles;
  public
    { Konstruktor & Destruktor }
    Constructor Create;
    Destructor Destroy; override;
    { Wczytanie plikow i posegregowanie ich do odpowiednich list ze wzgledu na 1 litere
    i potem wylosowanie odpiednie i calosc reszta }
    Procedure SeparateFiles;
  end;
  
{ Jeden obiekt typu THelloClass }
var
  HelloO : THelloClass;

{ THelloClass }

function THelloClass.CheckChar(c: Char): Integer;
begin
  result := -1;
  case c of
    'h' : result := 0;
    'e' : result := 1;
    'l' : result := 2;
    'o' : result := 3;
    'w' : result := 4;
    'r' : result := 5;
    'd' : result := 6;
  end;
end;

constructor THelloClass.Create;
var
  i : Integer;
begin
  { Tworzymy 7 list }
  for i := 0 to 6 do
    CharList[i] := TStringList.Create;
end;

destructor THelloClass.Destroy;
var
  i : Integer;
begin
  { Kasujemy Listy }
  for i := 0 to 6 do
    FreeAndNil(CharList[i]);
  FreeAndNil(ResultList);
end;


procedure THelloClass.RandomFiles;
var
  seed : Integer;
  i : Integer;
  deleted : String;

  { Taka pomocnicza procedurka zeby nie pisac wciaz tego samego }
  Procedure AddToList(Lst : Integer);
  var
    src : String;
  begin
    if (Lst = -1) then
      begin
        ResultList.Add('');
      end
        else
          begin
            seed := Random(CharList[Lst].Count);
            src := CharList[Lst].Strings[seed];
            Delete(src, 2, Length(src));
            ResultList.Add(src);
          end;
  end;

begin
  ResultList := TStringList.Create;

  { Losujemy z plik z puli nazw na H }
  AddToList(0);
  { Losujemy z nazw na E }
  AddToList(1);
  { Teraz na L 2 razy pod rzad }
  AddToList(2);
  AddToList(2);
  { Z Liter oo }
  AddToList(3);
  { Spacja }
  AddToList(-1);
  { Litera W }
  AddToList(4);
  { Znow litera oooO }
  AddToList(3);
  { R }
  AddToList(5);
  { L }
  AddToList(2);
  { D }
  AddToList(6);

  { Wyswietlamy juz same literki z wycietych nazw plikow }
  for i := 0 to ResultList.Count - 1 do
    WriteLn(ResultList.Strings[i]);
end;

procedure THelloClass.SeparateFiles;
var
  CR : Integer;
begin
  { Pobieramy sciezke do windowsa wpierw }
  GetWindowsDirectory(WinPath, MAX_PATH);

  { Teraz pobieramy wszystkie pliki z tego katalogu i sprawdzajac 1 literke wrzucamy do
  odpowiednich list }
  if FindFirst(WinPath + '\*.*', faAnyFile, SRes) = 0 then
    begin
      repeat

        { Zmieniamy na male litery nazwe }
        SRes.Name := CharLower(PAnsiChar(SRes.Name));
        { Sprawdzamy pierwsza litere nazwy pliku i przypisujemy do odpowiedniej listy }
        CR := CheckChar(SRes.Name[1]);
        if CR > - 1 then
          CharList[CR].Add(SRes.Name);

      until FindNext(SRes) <> 0;
      FindClose(SRes);
    end;

  RandomFiles;

end;

begin
  Randomize;
  HelloO := THelloClass.Create;
  HelloO.SeparateFiles;

  Readln;
  FreeAndNil(HelloO);
end.

